package nl.sbdeveloper.themeparkplus.listeners;

import club.minnced.discord.webhook.send.WebhookEmbed;
import club.minnced.discord.webhook.send.WebhookEmbedBuilder;
import nl.iobyte.themepark.api.attraction.component.Status;
import nl.iobyte.themepark.api.attraction.manager.StatusManager;
import nl.iobyte.themepark.api.events.attraction.ChangeStatusEvent;
import nl.sbdeveloper.themeparkplus.ThemeParkPlus;
import nl.sbdeveloper.themeparkplus.util.ConfigUtil;
import org.bukkit.ChatColor;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.jetbrains.annotations.NotNull;

/**
 * Status change listener for discord webhook
 */
public class StatusChangeListener implements Listener {
    @EventHandler
    public void onStatusChange(@NotNull ChangeStatusEvent e) {
        if (e.getAfter() != Status.GLOBAL) {
            String title = ThemeParkPlus.getSConfig().getFile().getString("DiscordWebhook.Embed.Title");
            if (title == null) return;

            String rideName = ChatColor.stripColor(ConfigUtil.makecolored(e.getAttraction().getName()));
            String statusAfter = ChatColor.stripColor(ConfigUtil.makecolored(StatusManager.getName(e.getAfter())));

            title = title.replaceAll("%RideName%", rideName);
            String copy = ThemeParkPlus.getSConfig().getFile().getString("DiscordWebhook.Embed.Copyright");
            String copyimg = ThemeParkPlus.getSConfig().getFile().getString("DiscordWebhook.Embed.CopyrightImage");
            Integer color = ThemeParkPlus.getSConfig().getFile().getInt("DiscordWebhook.Embed.Colors." + e.getAfter().toString());
            if (copy == null || copyimg == null) return;

            WebhookEmbed embed = new WebhookEmbedBuilder()
                .setTitle(new WebhookEmbed.EmbedTitle(title, ""))
                .setFooter(new WebhookEmbed.EmbedFooter(copy, copyimg))
                .setColor(color)
                .addField(new WebhookEmbed.EmbedField(false, rideName, statusAfter))
                .build();

            ThemeParkPlus.getWebhookClient().send(embed);
        }
    }
}
